c###genois.for
      SUBROUTINE GENOIS4(rcnse_x,du_x,dl_x,sigm_x,sygu_x,sygl_x,rnse)
c          GENOIS for Power sum #4 = simple power sum
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
C--------------------------------
C
C     THIS ROUTINE COMPUTES THE COMBINED NOISE DISTRIBUTION - as prescribed
C       in ITS Report 87-212 "Updated NOISE Model for use in IONCAP"
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      DIMENSION XNINT(4)
C.....MAN-MADE NOISE LEVELS
      DATA XNINT /76.8, 72.5, 67.2, 53.6/
C
      DATA DFAC,BFAC,CFAC /7.87384, 30.99872, 5.56765/
C
C        7.87384=SQRT(2 * 1.282**2 * 4.34294**2)
C
C       30.99872=(1.282**2)*(4.34294**2)
C
C        5.56765=4.34294 * 1.282
C
C.....DATA ARE FA VALUES AT 1 MHZ
C
C.....ATNU, ATNY ARE DB .GT. KTB FOR 1 MHZ
C.....ATNZ, ATNX ARE DB .GT. KTB FOR FREQ
C.....ATNOS, GNOS, XNOIS ARE DB .GT. KTB FOR ALL CALCULATIONS
C.....AND ARE CONVERTED TO DBW(1 HZ BWDTH) AT END OF ROUTINE
C.....UPPER LIMIT IS 55 MHZ FOR NOISE
      DUME=AMIN1(FREQ,55.)
      xMAN=float(NOISE)/10.    !  convert back
      man=xman
C
C     FREQUENCY DEPENDENT ATMOSPHERIC NOISE
C
      IF (F2D(1,1,1)) 85,90,90
C.....NO IONOSPHERIC LONG TERM DATA BASE FILE
C.....FORCE MAN-MADE NOISE OR GALACTIC NOISE
   85 ATNOS=204.
      atnos=0.
      DUA=9.
      DLA=7.
      SMA=3.
      SUA=1.5
      SLA=1.5
      GO TO 95
   90 CONTINUE
C.....FREQUENCY DEPENDENCE
      CALL GENFAM(RLAT,KJ,DUME,ATNU,ATNZ,DU,DL,SIGM,SYGU,SYGL)
ccc      write(*,'(''genfam='',i5,5f10.4)') kj,freq,atnu,atnz,du,dl
ccc      CALL GENFAM(RLAT,JK,DUME,ATNY,ATNX,DX,DQ,SIGZ,SIGX,SIGSQ)
ccc      write(*,'(''genfam='',i5,5f10.4)') jk,freq,atny,atnx,dx,dq
C.....BEGIN INTERPOLATION ON LOCAL TIME
ccc      SLOP=ABS(CC-TM)/4.
ccc      ATNOS=ATNZ+(ATNX-ATNZ)*SLOP
      atnos=atnz
      dua=du
      dla=dl
      sma=sigm
      sua=sygu
      sla=sygl
ccc      write(*,'(''atnos='',5f10.4)') atnos,atnz,atnx,atnz,slop
ccc      DUA=DU+(DX-DU)*SLOP
ccc      DLA=DL+(DQ-DL)*SLOP
ccc      SMA=SIGM+(SIGZ-SIGM)*SLOP
ccc      SUA=SYGU+(SIGX-SYGU)*SLOP
ccc      SLA=SYGL+(SIGSQ-SYGL)*SLOP
ccc      write(*,'(''atnos='',3f10.4)') atnos,dua,dla
C.....END OF INTERPOLATION ON LOCAL TIME
C
C     (DUA/DFAC)**2=(DUA/1.282)**2/(2*4.34294**2)
C                  =(DUA/SQRT(2*1.282**2*4.34294**2))**2
C                  =(DUA/7.87384)**2
C
95    continue
      atnos_sav=atnos
      if(mode_n1.eq.0) atnos=204.
      if(mode_n1.eq.0) atnos=0.
ccc      write(*,'(''au='',4f15.4)') au,dua,dfac,atnos
C
      atnos=atnos_sav
c****************************************************************
C
C     GALACTIC NOISE
C
c          Since we are not running propagation, we do not know FI(3,KFX)
cccc      IF (FREQ-FI(3,KFX)) 100,100,105
ccccC.....GALACTIC NOISE DOES NOT PENETRATE
cccc  100 GNOS=0.
cccc      GO TO 110
  105 GNOS=52.-23.*ALOG10(FREQ)
  110 DUG=2.
      DLG=2.
      SMG=.5
      SUG=.2
      SLG=.2
      if(mode_n2.eq.0) gnos=0.    !  ignore galactic noise
ccc      write(*,'(''gnos='',f10.4)') gnos
ccc      write(*,'(''gnos ='',3f10.4)') gnos,dug,dlg
c****************************************************************
C
C     MAN MADE NOISE
C
ccc      MAN=NOISE
      MAN=xman
      if(man.le.4.) man=-man   !  for index 1,2,3,4
      XNOIS=xMAN
      if(mode_n3.eq.0) xnois=300.
      MA=IABS(MAN)
      ZNOISE=XNOIS
      IF (MAN) 120,114,115
C.....INDICATES -164 ON USER INPUT
  114 MA=4
      GO TO 120
C.....CONVERT 3 MHZ DB .LT. 1 WATT INPUT VALUE TO FA AT 1 MHZ
  115 XNOIS=204.0-XNOIS+13.22
C.....OBTAIN FA AT DESIRED FREQUENCY
      XNOIS=XNOIS-27.7*ALOG10(FREQ)
      GO TO 125
C.....NEGATIVE ON USER INPUT INDICATES INDEX
  120 MA=MIN0(4,MA)
      CONN=27.7
ccc      IF (MA.EQ.4) CONN=28.6
      XNOIS=XNINT(MA)-CONN*ALOG10(FREQ)
      ZNOISE=204.0-XNINT(MA)+13.22
ccc      if(ma.eq.4) znoise=163.6
  125 DUM=9.7
ccc      write(*,'(''znoise='',2f12.5,i5)') znoise,xnois,man
      DLM=6.
      SUM=1.5
      SMM=5.4
      SLM=1.5
      if(mode_n3.eq.0) xnois=0.
ccc      write(*,'(''mnos ='',3f10.4)') xnois,dum,dlm
c****************************************************************
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....RECEIVER ANTENNA EFFICIENCY
C125PC      if(MSPEC.eq.125)then
c.......set rec EFF to 0. dB or unity
C125PC        reff=0.
C125PC      else
      reff=0
cccccccc        CALL GAIN(2,0.0,FREQ,GDUM,reff)
C125PC      ENDIF
C.....SET ARRAY FOR ALL POSSIBLE MODES
      DO 196 IM=1,6
  196 EFF(IM) = reff
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....NOW DETERMINATION OF NOISE LEVEL IS ITS-78 (HFMUFES4)
C.....SWITCH TO DB .GT. WATT
      ATNOS=ATNOS-204.
      GNOS=GNOS-204.
      XNOIS=XNOIS-204.

      xn_atnos=atnos
      xn_galactic=gnos
      xn_mmn=xnois
      rnse=4.34294*alog((10.**(atnos*.1))+(10.**(gnos*.1))
     +     + 10.**((xnois*.1)))
c*************************************************************
c          This is where the simple power sum is done
c*************************************************************
      xrnse=4.34294*alog((10.**(atnos*.1))+(10.**(gnos*.1))
     +     + 10.**((xnois*.1)))
      du=abs(4.34294*alog(10.**((atnos+dua)*.1) +
     +         10.**((gnos+dug)*.1) +
     +         10.**((xnois+dum)*.1)) - xrnse)
      dl=abs(4.34294*alog(10.**((atnos+dla)*.1) +
     +         10.**((gnos+dlg)*.1) +
     +         10.**((xnois+dlm)*.1)) - xrnse)
      if(mode_n1.eq.1 .and. mode_n2+mode_n3.eq.0) then    !  atmospheric only
         xrnse=atnos
         du=dua
         dl=dla
      else if(mode_n2.eq.1 .and. mode_n1+mode_n3.eq.0) then !  galactic only
         xrnse=gnos
         du=dug
         dl=dlg
      else if(mode_n3.eq.1 .and. mode_n1+mode_n2.eq.0) then !  man-made only
         xrnse=xnois
         du=dum
         dl=dlm
      end if
      QPA=10.**((ATNOS-XRNSE)*0.1)
      if(mode_n1.eq.0) QPA=0.     !  no atmospheric noise
      QPG=10.**((GNOS-XRNSE)*0.1)
      if(mode_n2.eq.0) QPG=0.     !  no galactic    noise
      QPM=10.**((XNOIS-XRNSE)*0.1)
      if(mode_n3.eq.0) QPM=0.     !  no man-made   noise
      SIGM=SQRT((QPA*SMA)**2+(QPG*SMG)**2+(QPM*SMM)**2)  !  /QP
      sygu=sqrt((dua*sua*qpa**2/du)**2 +
     +          (dug*sug*qpg**2/du)**2 +
     +          (dum*sum*qpm**2/du)**2)
      sygl=sqrt((dla*sla*qpa**2/dl)**2 +
     +          (dlg*slg*qpg**2/dl)**2 +
     +          (dlm*slm*qpm**2/dl)**2)
c*************************************************************
c          End simple power sum
c*************************************************************
ccc      write(*,'(''sigm ='',4f12.4)') sigm,sma,smg,smm
ccc      write(*,'(''sigu ='',4f12.4)') sygu,sua,sug,sum
ccc      write(*,'(''sigl ='',4f12.4)') sygl,sla,slg,slm
ccc      write(*,'(''xrnse='',5f12.4)') 
ccc     +   xrnse+204.,atnos+204.,gnos+204.,xnois+204.,rnse+204.
ccc      write(*,'(''QP   ='',3f12.4)') qpa,qpg,qpm
C
C     RCVR SITE NOISE = TOTAL NOISE + ANTENNA EFFICENCY (ADDED TO
C                       SIGNAL WITH GAIN)
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------          210 RCNSE = XRNSE + reff
      RCNSE = XRNSE
      XNOISE=XNOIS
      rcnse_x=rcnse
ccc      write(*,'(''xnois='',4f10.4)') rcnse+204.,atnos+204.,
ccc     +          gnos+204.,xnois+204.
      du_x=du
      dl_x=dl
      sigm_x=sigm
      sygu_x=sygu
      sygl_x=sygl
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      RETURN
      END
C--------------------------------
