      winapp 80000,260000
      PROGRAM gh_noise
      include <windows.ins>
C***********************************************************************
C***********************************************************************
c  Written Feb 2007 by Greg Hand to distribute to the ITU
C***********************************************************************
      common /c_version/ version
         character version*40
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3
C---------------------------------
C
C  D     INCLUDE 'NEWCAP.DOC/LIST'      ! 3 additional PAGEs of INFO
C
C WEIGHTS AND ABSCISSCAE FOR 40 POINT GUASSIAN SET BELOW:
      COMMON / DATR /  WT(20), XT(20), NT, NPL, XNPL, TWDIV
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16,
     1                 LU20, LU25, LU26, LU35
C NUMERICAL MAP COEFICENTS (SEE REDMAP):
      COMMON / ONE /   IA(6), IB(6), IKIM(10,6), ESLCOF(5,55),
     1                 ESMCOF(7,61), ESUCOF(5,55), F2COF(13,76),
     2                 FM3COF(9,49), ERCOF(9,22)
C MORE COEFICENTS AND TABLES (SEE REDMAP):
      COMMON / TWO /   F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     1                 FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON /TWO_AB/ AB(318)
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
C  PROGRAM VERSION NUMBER, PROGRAM CONTROL VARIABLES
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)

      common /cQUIET/ iquiet
      integer (kind=3) count_underflow
      logical (kind=2) permission
C
C SET PREDEFINED CONSTANTS:
C
      DIMENSION IIA (6), IIB (6)
C
      DATA IIA / 1,276,703,978,1966,2407 /
      DATA IIB / 5, 7, 5, 13, 9, 9 /
C
      F2D(1,1,1) = -1.
      DO 10 I = 1, 6
      IA (I) = IIA (I)
 10   IB (I) = IIB (I)
C  DEFINE NT - POINT GAUSSIAN INTEGRATION
      NT = 20
C  USE LINEAR INTERVAL TRANSFORMATION TO (-1,1)
      NPL = 1
      XNPL = NPL
      TWDIV = 1. / (2. ** NPL)
c******************************************************
      permission=.true.        !  ignore underflows
ccc      permission=.false.
      call permit_underflow@(permission)
c******************************************************
ccc      open(81,file='hf_noise.txt')
ccc      rewind(81)
c******************************************************
      iquiet=1
c******************************************************
      version='Version ???'
      open(21,file='database\version.txt',status='old',err=20)
      rewind(21)
      read(21,'(a)') version
      close(21)
c***********************************************************************
20    call create_save   !  make sure "gh_noise.txt" exists
      call screen
c***********************************************************************
c          save current data for re-entry
      open(21,file='gh_noise.dat')
      rewind(21)
      write(21,951) iseason,lhour,freq,xnoise,rlat,rlon
951   format(2i5,f8.3,f7.1,2f12.4)
      close(21)
c******************************************************************
c         close and delete temporary files
      call underflow_count@(count_underflow)  !  see if any underflows occured
ccc      write(*,'(''underflow='',i8)') count_underflow
      END
c--------------------------------------------------------------
      subroutine create_save   !  make sure "gh_noise.txt" exists
      open(21,file='gh_noise.txt',status='old',err=100)
      close(21)
      return    !  file exists, so do nothing
c          file does not exist, so create it an put outheader.
100   open(21,file='gh_noise.txt')
      write(21,1)
1     format('      Se TB FreqMHz   MMN  Latitude Longitude',
     +   '    NdBW     Fam      DL      DU SigmaLW  SigmaN SigmaUP')
ccc     +   '     Fam')
      close(21)
      return
      end
c-----------------------------------------------------------------
