c###single.for
      SUBROUTINE single(luout,monthx,ihour,freqx,xxnoise,rlatx,rlongx)
c         for this code, ihour=time block (1-6)
      common /r_noise/ cnoise,xdu,xdl,xsigm,xsygu,xsygl
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      character equ*1
C--------------------------------
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      character noise_alf(3)*2
      character psum(4)*1,codes*5,psuma*1
      data psum/'m','l','w','s'/
      data noise_alf/' A',' G',' M'/
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
ccc      call setvars     !  set variables that are undefined
c*****************************************************************
c          mate MONTHs to SSNs per VOA request May 1993
c          required major changes to DECRED and following loop
ccc      write(81,1) monthx,ihour,freqx
ccc1     format('Month=',i3,'   hour=',i2,'  freq=',f8.3)
      MONTH=monthx
      noise=xxnoise*10. + .5
      rlatd=rlatx
      rlongd=rlongx
      RLAT = RLATD * D2R
      RLONG = RLONGD * D2R
      if(abs(rlatd).gt.89.9) rlong=0.     !  at poles, force long=0
      if(abs(tlatd).gt.89.9) tlong=0.     !  at poles, force long=0
      call REDMAP2(MONTH)
c*****************************************************************
C.....BEGIN HOUR LOOP
      JT=ihour
      JTX = 1
C.....CONVERT UT TO LMT, ETC.
      CALL GEOTIM(JT)
      freq=freqx
      call anois1(ihour)   !  get noise value at 1 MHz for receiver site
c                          !  noise distribution
      call genois(cnoise,xdu,xdl,xsigm,xsygu,xsygl,xnoiseS)

ccc      call report(xxnoise)     !  compare differences between Modified Spaulding and 12dB limit
ccc      call report2(xxnoise)     !  compare differences between Modified Spaulding and 12dB limit
      RETURN
      END
c-----------------------------------------------------------------
c###report.for
      SUBROUTINE report(xxnoise)
      common /c_method_used/ method_used
c          for this code, ihour=time block (1-6)
c          and the grid will be done so as to match the plots of Report 322-3.
c          That means Longitude will go from 60E on the left and be cenetered at 120W.
C--------------------------------
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /c_version/ version
         character version*40
      dimension emin(6),emax(6),diff(6)
      character season_alf(12)*6,noise_code(4)*30,timeblock(6)*10
      character noise_alf(3)*2,equ*1,psum(4)*1,codes*5,psuma*1
      data noise_alf/' A',' G',' M'/
      data psum/'m','l','w','s'/
      data season_alf/'Winter','Winter','Spring','Spring',
     +                'Spring','Summer','Summer','Summer',
     +                'Autumn','Autumn','Autumn','Winter'/
      data noise_code/'Industrial (-140.4 MMN)',
     +                'Residential (-144.7 MMN)',
     +                'Rural (-150.0 MMN)',
     +                'Remote (-163.6 MMN)'/
      data timeblock/'0000-0400','0400-0800','0800-1200',
     +               '1200-1600','1600-2000','2000-2400'/
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
c*****************************************************************
      open(31,file='report.txt')
      rewind(31)

      do 500 kknoise=1,4
      xxnoise=kknoise
      write(31,'(/,26x,''Man-made Noise= '',a)') noise_code(kknoise)
      write(31,1) 
1     format(17x,
     +'Fam         DL         DU      SigmaLW    SigmaN    SigmaUP')
c234567890123456789012345678901234567890123456789012345678901234567890
      write(31,2) 
2     format('  Frequency ',6('   Min/Max '))
c*****************************************************************
      noise=xxnoise*10. + .5
      do 500 ifreq=1,30
      freq=ifreq
      do 10 i=1,6
      emin(i)=99999.
10    emax(i)=-99999.
      write(*,'(''ifreq='',2i5)') kknoise,ifreq
      icount1=0
      do 400 month=1,10,3      !  4 seasons
      call REDMAP2(MONTH)
      do 400 ihour=1,6         !  6 time blocks
      JT=ihour
      JTX = 1
      nx=61
      ny=61
ccc      write(luout,'(''GH_NOISE'',2x,a)') version
ccc      equ='n'       !  no equator interpolation
ccc      if(mode_s2.ne.0) equ='i'     !  interpolate at equator
ccc      psuma=psum(1)
ccc      if(mode_l2.eq.1) psuma=psum(2)
ccc      if(mode_l3.eq.1) psuma=psum(3)
ccc      if(mode_l4.eq.1) psuma=psum(4)
ccc      write(codes,'(5a1)') noise_alf(1)(mode_n1+1:mode_n1+1),
ccc     +               noise_alf(2)(mode_n2+1:mode_n2+1),
ccc     +               noise_alf(3)(mode_n3+1:mode_n3+1),equ,
ccc     +               psuma
ccc      if(noise.ge.1 .and. noise.le.4) then
ccc      write(luout,3) season_alf(monthx),timeblock(ihour),freq,
ccc     +               noise_code(noise),codes
ccc3     format(a,' LT=',a,f7.3,'MHz',1x,a,' (',a5,')')
ccc      else
ccc      write(luout,1) season_alf(monthx),timeblock(ihour),freq,
ccc     +              -xxnoise,codes
ccc1     format(a,' LT=',a,f7.3,'MHz',f7.1,'MMN',' (',a5,')')
ccc      end if
ccc      write(luout,2) nx,ny
ccc2     format(2i3,'  Latitude Longitude    NdBW     Fam',
ccc     +           '      DL      DU SigmaLW  SigmaN SigmaUP    dFam')
ccc     +           '     Fam')
C.....CONVERT UT TO LMT, ETC.
      do 200 iy=1,ny
      rlatd=-90 + (iy-1)*3
      do 200 ix=1,nx
ccc      rlongd=-180 + (ix-1)*6
      rlongd=60 + (ix-1)*6     !  this will center plot at 120W
      if(rlongd.gt.180.) rlongd=rlongd-360.
      RLAT = RLATD * D2R
      RLONG = RLONGD * D2R
      if(abs(rlatd).gt.89.9) rlong=0.     !  at poles, force long=0
      if(abs(tlatd).gt.89.9) tlong=0.     !  at poles, force long=0
      CALL GEOTIM(JT)
      call anois1(ihour)       !  get noise value at 1 MHz for receiver site
c                          !  noise distribution
ccc      mode_s1=0
ccc      mode_s2=1     !  interpolate equator
      call genois1(xnoise1,xdu1,xdl1,xsigm1,xsygu1,xsygl1,xnoiseS1)
      if(method_used.eq.1) icount1=icount1+1
ccc      mode_s1=1     !  normal equator
ccc      mode_s2=0
      call genois2(xnoise2,xdu2,xdl2,xsigm2,xsygu2,xsygl2,xnoiseS2)
      diff(1)=xnoise1-xnoise2
      diff(2)=xdl1-xdl2
      diff(3)=xdu1-xdu2
      diff(4)=xsygl1-xsygl2
      diff(5)=xsigm1-xsigm2
      diff(6)=xsygu1-xsygu2
      do 20 i=1,6
      if(diff(i).lt.emin(i)) emin(i)=diff(i)
      if(diff(i).gt.emax(i)) emax(i)=diff(i)
20    continue
ccc      write(luout,101) ix,iy,rlatd,rlongd,
ccc     +            xnoise,xnoise+204.,xdl,xdu,xsygl,xsigm,xsygu
ccc     +            ,xnoise-xnoiseS     !  diff from power sum
ccc     +           ,xn_atnos+204.
ccc101   format(2i3,2f10.4,8f8.2)
200   continue
400   continue
      used=float(icount1)/float(4*6*nx*ny)*100.
      write(31,402) ifreq,(emin(i),emax(i),i=1,6),used
402   format(i5,' MHz',3x,6(f6.1,1h/,f4.1),3x,f6.2)
500   continue
      close(31)

      RETURN
      END
C---------------------------------
c###report.for
      SUBROUTINE report2(xxnoise)
      common /c_method_used/ method_used
c          for this code, ihour=time block (1-6)
c          and the grid will be done so as to match the plots of Report 322-3.
c          That means Longitude will go from 60E on the left and be cenetered at 120W.
C--------------------------------
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /c_version/ version
         character version*40
      dimension emin(6),emax(6),diff(6),kklat(911),kklon(911)
      character season_alf(12)*6,noise_code(4)*30,timeblock(6)*10
      character noise_alf(3)*2,equ*1,psum(4)*1,codes*5,psuma*1
      character ns*1,ew*1
      data noise_alf/' A',' G',' M'/
      data psum/'m','l','w','s'/
      data season_alf/'Winter','Winter','Spring','Spring',
     +                'Spring','Summer','Summer','Summer',
     +                'Autumn','Autumn','Autumn','Winter'/
      data noise_code/'-140.4 dBW/Hz Industrial',
     +                '-144.7 dBW/Hz Residential',
     +                '-150.0 dBW/Hz Rural',
     +                '-163.6 dBW/Hz Remote'/
      data timeblock/'0000-0400','0400-0800','0800-1200',
     +               '1200-1600','1600-2000','2000-2400'/
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
c*****************************************************************
      open(29,file='cirafp.911',status='old')
      rewind(29)
      do 155 i=1,911
      read(29,'(4x,i2,a1,i3,a1)') ilat,ns,ilon,ew
      if(ns.eq.'S') ilat=-ilat
      if(ew.eq.'W') ilon=-ilon
      kklat(i)=ilat
155   kklon(i)=ilon
      close(29)
c*****************************************************************
      open(31,file='report.txt')
      rewind(31)

      do 500 kknoise=1,4
      xxnoise=kknoise
      write(31,'(/,26x,''Man-made Noise= '',a)') noise_code(kknoise)
      write(31,1) 
1     format(17x,
     +'Fam         DL         DU      SigmaLW    SigmaN    SigmaUP')
c234567890123456789012345678901234567890123456789012345678901234567890
      write(31,2) 
2     format('  Frequency ',6('   Min/Max '))
c*****************************************************************
      noise=xxnoise*10. + .5
      do 500 ifreq=1,30
      freq=ifreq
      do 10 i=1,6
      emin(i)=99999.
10    emax(i)=-99999.
      write(*,'(''kknoise,ifreq='',2i5)') kknoise,ifreq
      icount1=0
      do 400 month=1,10,3      !  4 seasons
      call REDMAP2(MONTH)
      do 400 ihour=1,6         !  6 time blocks
      JT=ihour
      JTX = 1
      nx=61
      ny=61
ccc      write(luout,'(''GH_NOISE'',2x,a)') version
ccc      equ='n'       !  no equator interpolation
ccc      if(mode_s2.ne.0) equ='i'     !  interpolate at equator
ccc      psuma=psum(1)
ccc      if(mode_l2.eq.1) psuma=psum(2)
ccc      if(mode_l3.eq.1) psuma=psum(3)
ccc      if(mode_l4.eq.1) psuma=psum(4)
ccc      write(codes,'(5a1)') noise_alf(1)(mode_n1+1:mode_n1+1),
ccc     +               noise_alf(2)(mode_n2+1:mode_n2+1),
ccc     +               noise_alf(3)(mode_n3+1:mode_n3+1),equ,
ccc     +               psuma
ccc      if(noise.ge.1 .and. noise.le.4) then
ccc      write(luout,3) season_alf(monthx),timeblock(ihour),freq,
ccc     +               noise_code(noise),codes
ccc3     format(a,' LT=',a,f7.3,'MHz',1x,a,' (',a5,')')
ccc      else
ccc      write(luout,1) season_alf(monthx),timeblock(ihour),freq,
ccc     +              -xxnoise,codes
ccc1     format(a,' LT=',a,f7.3,'MHz',f7.1,'MMN',' (',a5,')')
ccc      end if
ccc      write(luout,2) nx,ny
ccc2     format(2i3,'  Latitude Longitude    NdBW     Fam',
ccc     +           '      DL      DU SigmaLW  SigmaN SigmaUP    dFam')
ccc     +           '     Fam')
C.....CONVERT UT TO LMT, ETC.
      do 200 ii=1,911
ccc      rlongd=-180 + (ix-1)*6
      rlatd=kklat(i)
      rlongd=kklon(i)
      RLAT = RLATD * D2R
      RLONG = RLONGD * D2R
      if(abs(rlatd).gt.89.9) rlong=0.     !  at poles, force long=0
      if(abs(tlatd).gt.89.9) tlong=0.     !  at poles, force long=0
      CALL GEOTIM(JT)
      call anois1(ihour)       !  get noise value at 1 MHz for receiver site
c                          !  noise distribution
      call genois1(xnoise1,xdu1,xdl1,xsigm1,xsygu1,xsygl1,xnoiseS1)
      if(method_used.eq.1) icount1=icount1+1
      call genois3(xnoise2,xdu2,xdl2,xsigm2,xsygu2,xsygl2,xnoiseS2)
      diff(1)=xnoise1-xnoise2
      diff(2)=xdl1-xdl2
      diff(3)=xdu1-xdu2
      diff(4)=xsygl1-xsygl2
      diff(5)=xsigm1-xsigm2
      diff(6)=xsygu1-xsygu2
      do 20 i=1,6
      if(diff(i).lt.emin(i)) emin(i)=diff(i)
      if(diff(i).gt.emax(i)) emax(i)=diff(i)
20    continue
ccc      write(luout,101) ix,iy,rlatd,rlongd,
ccc     +            xnoise,xnoise+204.,xdl,xdu,xsygl,xsigm,xsygu
ccc     +            ,xnoise-xnoiseS     !  diff from power sum
ccc     +           ,xn_atnos+204.
ccc101   format(2i3,2f10.4,8f8.2)
200   continue
400   continue
      used=float(icount1)/float(4*6*911)*100.
      write(31,402) ifreq,(emin(i),emax(i),i=1,6)!,used
402   format(i5,' MHz',3x,6(f6.1,1h/,f4.1),3x,f6.2)
500   continue
      close(31)

      RETURN
      END
C---------------------------------
