      integer*4 function printer()
      common /c_printer_dialog/ printer_dialog_setup
         integer*4 printer_dialog_setup
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      include <windows.ins>
      common /LAST_PARM/ iplast             !  last parameter plotted
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      integer*4 screen_dc,printer_dc,hnd1,hnd2
      data hnd1,hnd2/1,2/

      call printer_setup_read     !  read values on ..\database\print.ini
      call get_current_dc@(screen_dc)    !  get handle of the screen
      ndpi=150
      if(printer_dialog_setup.eq.0) then
         ires=open_printer@(hnd2)      !  open printer
         if(ires.ne.0) printer_dialog_setup=1
      else
         ires=open_printer1@(hnd2)     !  open printer
      end if
      if(ires.eq.0) go to 999    !  print request cancelled
      call get_current_dc@(printer_dc)   !  get handle of the printer
      leny=GetDeviceCaps(printer_dc,VERTRES)   !  vertical resolution
      lenx=GetDeviceCaps(printer_dc,HORZRES)   !  horizontal resolution
      ixoff=0
      iyoff=0
      if(leny.gt.lenx) then
         leny=lenx*2400/3160
      end if
      if(scale_factor.lt..99) then
         lenx=nint(float(lenx)*scale_factor)
         leny_t=nint(float(leny)*scale_factor)
ccc         ixoff=Xoffset*float(ndpi)
ccc         iyoff=Yoffset*float(ndpi)
         ixoff=Xoffset*300.
         iyoff=Yoffset*300.
         iyoff=leny-leny_t - iyoff
         leny=leny_t
      end if
      idev=1                     !  flag this as printer
      call parms_plt(iplast)     !  re-draw the map
      ires=close_printer@(hnd2)  !  print output
      idev=0                     !  flag this as screen
      call select_graphics_object@(hnd1)      !  back to the screen
      leny=GetDeviceCaps(screen_dc,VERTRES)   !  vertical resolution
      lenx=GetDeviceCaps(screen_dc,HORZRES)   !  horizontal resolution
      call initt(-.875,0)             !  re-initialize screen scaling
999   printer=1
      return
      end
c-------------------------------------------------------------------
      subroutine printer_only(ip)
      common /c_printer_dialog/ printer_dialog_setup
         integer*4 printer_dialog_setup
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      include <windows.ins>
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      integer*4 printer_dc

      call printer_setup_read     !  read values on ..\database\print.ini

      if(printer_dialog_setup.eq.0) then
         ires=open_printer@(2)      !  open printer
         if(ires.ne.0) printer_dialog_setup=1
      else
         ires=open_printer1@(2)     !  open printer
      end if
      if(ires.eq.0) go to 999    !  print request cancelled
      call get_current_dc@(printer_dc)   !  get handle of the printer
      leny=GetDeviceCaps(printer_dc,VERTRES)   !  vertical resolution
      lenx=GetDeviceCaps(printer_dc,HORZRES)   !  horizontal resolution
      ixoff=0
      iyoff=0
      ndpi=150
      if(leny.gt.lenx) then
         leny=lenx*2400/3160
      end if
      if(scale_factor.lt..99) then
         lenx=nint(float(lenx)*scale_factor)
         leny_t=nint(float(leny)*scale_factor)
ccc         ixoff=Xoffset*float(ndpi)
ccc         iyoff=Yoffset*float(ndpi)
         ixoff=Xoffset*300.
         iyoff=Yoffset*300.
         iyoff=leny-leny_t - iyoff
         leny=leny_t
      end if
      idev=1                     !  flag this as printer
      call parms_plt(ip)         !  re-draw the map
      ires=close_printer@(2)     !  print output
      idev=0                     !  flag this as screen
999   return
      end
c-------------------------------------------------------------------
      integer*4 function color_printer()
      common /print_done/ pct_done,s_pct_done,icancel_print
         character s_pct_done*4
         real*8 pct_done
      save iprint_ctrl
      external cancel_print
      common /c_printer_dialog/ printer_dialog_setup
         integer*4 printer_dialog_setup
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      include <windows.ins>
      common /LAST_PARM/ iplast             !  last parameter plotted
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      integer*4 screen_dc,printer_dc

      call printer_setup_read     !  read values on ..\database\print.ini
      call get_current_dc@(screen_dc)    !  get handle of the screen
      ndpi=150
      if(printer_dialog_setup.eq.0) then
         ires=open_printer@(2)      !  open printer
         if(ires.ne.0) printer_dialog_setup=1
      else
         ires=open_printer1@(2)     !  open printer
      end if
      if(ires.eq.0) go to 999    !  print request cancelled
c*********************************************
      icancel_print=0
      pct_done=0.
      s_pct_done='  0%'
      k=winio@('%ca[Color Printing Progress]'//
     +         '%^bt[&Cancel]&',cancel_print)
      k=winio@('  Printing done: %tc[red]%4st&',s_pct_done)
      k=winio@('%lw',iprint_ctrl)        !  leave window open
c*********************************************
      call get_current_dc@(printer_dc)   !  get handle of the printer
      leny=GetDeviceCaps(printer_dc,VERTRES)   !  vertical resolution
      lenx=GetDeviceCaps(printer_dc,HORZRES)   !  horizontal resolution
      ixoff=0
      iyoff=0
      if(leny.gt.lenx) then
         leny=lenx*2400/3160
      end if
      lenx_new=leny*3160/2400
      if(lenx_new.lt.lenx) lenx=lenx_new
      if(scale_factor.lt..99) then
         lenx=nint(float(lenx)*scale_factor)
         leny_t=nint(float(leny)*scale_factor)
ccc         ixoff=Xoffset*float(ndpi)
ccc         iyoff=Yoffset*float(ndpi)
         ixoff=Xoffset*300.
         iyoff=Yoffset*300.
         iyoff=leny-leny_t - iyoff
         leny=leny_t
      end if
ccc      write(15,'('' color_printer lenx,leny='',2i5)') lenx,leny
      idev=2                     !  flag this as color printer
      call parms_plt(iplast)     !  re-draw the map
      ires=close_printer@(2)     !  print output
      idev=0                     !  flag this as screen
      call select_graphics_object@(1)     !  back to the screen
      leny=GetDeviceCaps(screen_dc,VERTRES)   !  vertical resolution
      lenx=GetDeviceCaps(screen_dc,HORZRES)   !  horizontal resolution
      call initt(-.875,0)             !  re-initialize screen scaling
999   color_printer=1
c*********************************************
      iprint_ctrl=0
      call window_update@(iprint_ctrl)    !  remove Color Printing message
c*********************************************
      return
      end
c-------------------------------------------------------------------
      integer*4 function printer_reset()
      common /c_printer_dialog/ printer_dialog_setup
         integer*4 printer_dialog_setup
      printer_dialog_setup=0      !  reset to ask dialog box questions again
      printer_reset=1
      return
      end
c-------------------------------------------------------------------
      integer*4 function cancel_print()
      common /print_done/ pct_done,s_pct_done,icancel_print
         character s_pct_done*4
         real*8 pct_done
      icancel_print=1
      cancel_print=1
      return
      end
c-------------------------------------------------------------------
