c# worldmap.for
      WINAPP 800000,800000
C------------------------------------------------------------------
        PROGRAM worldmap
      parameter (NGRID_DIM=361)
C******************************************************************
c    worldmap filename noplot
C                     filename - file in ..\RUN\ directory or
c                                full pathname
c                     noplot = ' ' = do worldwin plot with wait
c                            = 'n' = do worldwin plot with no wait
c                            = 'b' = do worldwin plot with no wait,force B/W
c                            = 'x' = do not do worldwin
c          Will create ????????.mxn  (contour file)
c                      where: x = index [1-9] of parameters contoured
C******************************************************************
      INCLUDE 'Ficepac.hdr'
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
      common /mouse_results/ mouse_message,minsxx,maxsxx,minsyy,maxsyy,
     +                       xxscal,yyscal,wxxmin,wyymin,lenyy
         character mouse_message*100
      common /c_wmap/ luc,xmina,xmaxa,ymina,ymaxa
      common /c_printer_dialog/ printer_dialog_setup
         integer*4 printer_dialog_setup
      common /c_menu_checks/ mode_color1,mode_color2,mode_BW,
     +                       mode_BW1,mode_BW2,mode_BW5
      INCLUDE <WINDOWS.INS>
      character noplot*1
      common /cversion/ version
      character version*40
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      COMMON /RUNDATA/ XMINL,YMINL,DX,DY,NX,NY
      COMMON /MAXS/ XMAXL,YMAXL
      common /zminmax/ zmin,zmax,labels
      character labels*60
      COMMON /cons/ NCONT,CONT(200),icolors(200)
      common /Cdigits/ idigits
      common /proj/ iproj,plat,plon
      common /colors/ icolor(6)
      common /cmodel/ model
         character model*6
      common /Cinfo/ info,time_alf
         character info*30,time_alf*20
      common /cgridvals/ gridvals(NGRID_DIM,NGRID_DIM,8)
      common /c_inpfile/ inpfile
         CHARACTER inpfile*80
      CHARACTER ich*1
      character card*170
      character names(8)*8,alf1*8,alf2*8
      character new_title*75,window_title*20
      character cmnam*64
      external printer,color_printer,printer_setup,printer_reset
      external ABOUT,clipbdCB
      external use_color1,use_color2,use_BW,use_BW1,use_BW2,use_BW5
      external notepadCB
      common /c_misc_stuff/ igridtype,label
         character label*75
      common /c_grid_minmax/ gridmin(8),gridmax(8)
      dimension iparm(8),vals(8)
ccc      character mapdone*60,run*80
      data nnames/7/         !  number of names in NAMES
C******************************************************************
ccc      open(15,file='worldmap.txt')
ccc      rewind(15)
C******************************************************************
      inpfile=cmnam()         !  get runstring filename
      noplot=cmnam()
ccc      write(*,'('' inpfile='',a)') inpfile
ccc      write(*,'('' noplot='',a)') noplot
      IF(inpfile(1:1).EQ.' ') inpfile='worldmap.txt'
      IF(inpfile(1:1).EQ.' ') GO TO 910    !  HELP information
ccc      write(*,'('' inpfile='',a)') inpfile
      call lcase(noplot,1)                 !  convert to lower case
      if(noplot.eq.' ') noplot='s'
c*******************************************************************
      printer_dialog_setup=0
c********************************************************************
      mode_color1=0            !  plot using color with contours
      mode_color2=0
      mode_BW=0
      mode_BW1=0
      mode_BW2=0
      mode_BW5=1
      nch=lcount(inpfile,80)
      window_title='WORLDMAP'
      ncht=lcount(window_title,20)
      if(noplot.ne.'p') then
         nch1=lcount(window_title,20)
         k=winio@('%ca['//window_title(1:ncht)//
     +           ' Map plot for file: '//
     +            inpfile(1:nch)//']&')
         k=winio@('%mn[E&xit]&','EXIT')
         k=winio@(
     +   '%mn[&Print[&Black/White,&Color,&Setup,~&Reset dialog box]]&',
     +             printer,color_printer,printer_setup,
     +             printer_dialog_setup,printer_reset)
         k=winio@('%mn[&Notepad[&View grid file]]&',notepadCB)
         k=winio@('%mn[&to Clipboard]&',clipbdCB)
      k=winio@('%mn[&Contours[#&Color w/contours,#&Color no contours,'//
     +            '#&Black/White plot default contours,'//
     +            '#&Black/White plot 1dB contours,'//
     +            '#&Black/White plot 3dB contours,'//
     +            '#&Black/White plot 5dB contours'//
     +            ']]&',
     +             mode_color1,use_color1,
     +             mode_color2,use_color2,
     +             mode_BW   ,use_BW   ,
     +             mode_BW1  ,use_BW1  ,
     +             mode_BW2  ,use_BW2  ,
     +             mode_BW5  ,use_BW5  )
         mouse_message='Pick (x,y) location for readout'
         k=WINIO@('%tc[BLUE]%100st%tc[BLACK]%nl&',mouse_message)
         call initt(.875,0)
      end if
c*******************************************************************
      idigits=0
      call DOScolr             !  load DOS color indexes
      call colordef            !  read default contour shading colors
      version='          '
c*******************************************************************
      call lcase(inpfile,80)                !  convert to lower case
      new_title='..'
c*******************************************************************
      model='NOISE'
C******************************************************************
ccc      xmin=-180.
ccc      xmax=180.
      xmin=60.                !  center plot at 120W
      xmax=420.
      ymin=-90.
      ymax=90.
      ngrid=61
      igridtype=1
      nparms=8
      parms(1)='NdBW'
      parms(2)='Fam'
      parms(3)='DL'
      parms(4)='DU'
      parms(5)='SigmaLW'
      parms(6)='SigmaN'
      parms(7)='SigmaUP'
      parms(8)='dFam'
      info=' '
      time_alf=' '
c          read COLOR & CITYNAME whether OLD or NEW format
      card='Black    :Blue     :Ignore   :Ignore   :Red      '//
     +     ':Black with shading'
      call col_FMT2(card,color)
      do 803 i=1,8
      nlevels(i)=0
      do 803 j=1,10
      conlevels(j,i)=-1
803   ishades(j,i)=-1
ccc      do 805 i=1,nparms
ccc      read (29,806) parms(i),nlevels(i),
ccc     +             (ishades(j,i),conlevels(j,i),j=1,nlevels(i))
ccc805   continue
      if(noplot.ne.'p') call parms_mn     !  create the Parameters %mn format
ccc806   format(10x,a,i4,10(i3,1x,f7.2))
c***************************************************************
      close(29)
c********************************************************************
      do 10 i=1,6
      icolor(i)=-1
      ich=color(i)(1:1)
      if(ich.ge.'0' .and. ich.le.'9') icolor(i)=ichar(ich)-ichar('0')
10    continue
      XMINL=XMIN
      YMINL=YMIN
      XMAXL=XMAX
      YMAXL=YMAX
      xmina=xmin
      xmaxa=xmax
      ymina=ymin
      ymaxa=ymax
C******************************************************************
      open(29,file=inpfile(1:nch),
     +     status='old',iostat=ios,err=905)
      rewind(29)
      read(29,'(10x,a)') version         !  read model version
      read(29,'(a)') label             !  read plot label
      if(new_title(1:3).ne.'.. ') label=new_title
      nnames=8
      read(29,11) nx,ny,(names(j),j=1,nnames)
11    format(2i3,20x,25a8)
15    if(names(nnames).eq.'      ') then
          nnames=nnames-1
          if(nnames.gt.0) go to 15
      end if
      DX=(XMAX-XMIN)/FLOAT(NX-1)
      DY=(YMAX-YMIN)/FLOAT(NY-1)
ccc      write(*,'(''nparms,nnames='',2i5)') nparms,nnames
ccc      write(*,'(''nx,ny='',2i5)') nx,ny
      do 30 i=1,nparms
      gridmin(i)=9999999.
      gridmax(i)=-gridmin(i)
      alf1=parms(i)
      nch1=8
      call rblankc(alf1,nch1)
ccc      write(*,12) i,parms(i),nch1,alf1
ccc12    format(i3,1h=,a,1h:,i1,1h:,a,1h:)
      do 20 j=1,nnames                 !  match parameters to indexes
      alf2=names(j)
      nch2=8
      call rblankc(alf2,nch2)
ccc      write(*,12) j,names(j),nch2,alf2
      if(alf1(1:nch1).ne.alf2(1:nch2)) go to 20   !  no match
      iparm(i)=j                       !  parameter index
20    continue
30    continue
      do 50 iy=1,ny
      do 50 ix=1,nx
      read(29,31) (vals(j),j=1,nnames)
31    format(26x,10f8.2)
      do 40 ip=1,nparms
      g=vals(iparm(ip))
      gridvals(ix,iy,ip)=g
      if(g.lt.-32000.) go to 40
      if(g.lt.gridmin(ip)) gridmin(ip)=g
      if(g.gt.gridmax(ip)) gridmax(ip)=g
40    continue
50    continue
      close(29)
ccc      open(29,file='worldmap.mod')
ccc      rewind(29)
ccc      write(29,'('' file='',a,i10,'' grids'')') inpfile,nx*ny
ccc      close(29)
c***************************************************************
      np1=2
      np2=2                          !  if normal,  do only 2nd parameter (Fam)
      if(noplot.eq.'p') then
         np1=1
         np2=nparms   !  if printer, do all parameters
      end if
ccc      if(noplot.eq.'s' .and. nparms.ne.1) np=0     !  if screen,  do none
      do 100 ip=np1,np2
      if(noplot.ne.'x') then
         if(noplot.eq.'b') then
            icolor(6)=2         !  force no shading
            noplot='n'          !  no wait
         end if
         if(noplot.eq.'p') then
            call printer_only(ip)
         else
            k=WINIO@('%mn[&Help[&About WORLDMAP]]',ABOUT)
            call ghcur
            call parms_plt(ip)
            call ghcur
         end if
      end if
100   continue
C******************************************************************
      go to 999
905   write(*,901) ios,inpfile
901   format('OPEN error=',i5,' file=',a)
      go to 990
910   stop 'Execute with: noiseplt filein'
990   pause 'Hit <cr> to continue.'
999   continue
ccc      open(41,file=mapdone(1:nch_done))  ! create file to let someone know we are done
ccc      close(41)
      END
C---------------------------------------------------------------------
      SUBROUTINE col_FMT2(card,color)
c          read the COLORS
      CHARACTER color(6)*6
      character card*80,ich*1,color_new(5)*6,shading*20
      character cities(6)*6,shads(7)*20
      character col_DOS*6
      data cities/'BLACK ','black ','RED   ','red   ','BLUE  ','blue  '/
      data shads/'Black with shading  ',
     +           'Red   with shading  ',
     +           'Black  NO  shading  ',
     +           'Red    NO  shading  ',
     +           'Shading, no contours',
     +           'Bin color shading   ',
     +           'Bin  B/W  shading   '/

         read(card,2) color_new,shading
2        format(5(a6,4x),a20)
         color(1)=col_DOS(icolDOS(color_new(1)),1)    !  GRID
         color(2)=col_DOS(icolDOS(color_new(2)),1)    !  COUNTRIES
         color(3)=col_DOS(icolDOS(color_new(3)),1)    !  ZONES
         color(5)=col_DOS(icolDOS(color_new(5)),1)    !  MAINBEAM
c***********************************
c          CITIES (4) is different
      color(4)='Ignore'
      do 10 i=1,6
      if(color_new(4).eq.cities(i)) write(color(4),'(i1)') i-1
10    continue
      call colortab(4,color(4))
c***********************************
c          SHADING (6) is different
      color(6)='Ignore'
      do 20 i=1,7
      if(shading.eq.shads(i)) write(color(6),'(i1)') i-1
20    continue
      call colortab(6,color(6))
c***********************************
      return
      end
c-----------------------------------------------------------------
