      subroutine getlevel(zmin,zmax,icode,ncolor,con,icolor)
c***********************************************************************
c          icode = 0 = use values given in CON (max of 6 allowed)
c                = 1 = ZMAX down in CON(1) increments, Min allowed CON(2)
c                = 2 = ZMIN to ZMAX in 6 steps
c                = 3 = ZMIN up in CON(1) increments, Max allowed CON(2)
c***********************************************************************
      dimension con(*),icolor(*)
      common /colors_con/ jcolor(7)    !  default colors for auto contouring
c***********************************************************************
      if(icode.eq.0) then
      else if(icode.eq.1) then    !  ZMAX down in CON(1) increments
         dcon=con(1)              !  delta contour
         idcon=anint(dcon)
         minz=anint(con(2))       !  minimum allowed
         maxz=ifix(zmax/dcon)*idcon
         if(zmax-float(maxz).gt..5) maxz=maxz+idcon
         num=(maxz-minz)/idcon + 1
ccc         if(num.gt.7) num=7
         if(num.le.0) then
            num=1
         else
            do 10 i=1,num
10          con(i)=maxz - (num-i)*idcon
         end if
         if(zmax.gt.con(num)) con(num)=con(num)+dcon
         ncolor=num
      else if(icode.eq.2) then    !  ZMIN to ZMAX in 7 steps
         minz=zmin
         maxz=zmax+.999
         istep=(maxz-minz+6)/7
         ncolor=7
         do 20 i=1,ncolor
         con(i)=maxz - (i-1)*istep
         if(con(i).lt.zmin) con(i)=-999.   !  no contours below minumum
20       continue
      else if(icode.eq.3) then    !  ZMIN up   in CON(1) increments
         dcon=con(1)              !  delta contour
         idcon=anint(dcon)
         maxz=anint(con(2))       !  maximum allowed
         minz=ifix(zmin/dcon+1.)*idcon
         if(minz.lt.0 .and. dcon.le.1.001) minz=minz-1   !  fix for negative noise
ccc         if(zmax-float(maxz).gt..5) maxz=maxz+idcon
         num=0
30       num=num+1
         con(num)=minz + (num-1)*idcon
         if(num.lt.100 .and. con(num).lt.zmax) go to 30
         if(zmax.ge.con(num)) con(num)=zmax+dcon
         ncolor=num
      end if
      if(ncolor.lt.7) then     !  always force 7 levels
         do 50 i=ncolor+1,7
50       con(i)=-999.
         ncolor=7
      end if
ccc      ncolor=7
      call sortx(ncolor,con)   !  sort from low to high
      do 60 i=1,ncolor
      j=mod(i-1,7)+1
60    icolor(i)=jcolor(i)
      return
      end
c-------------------------------------------------------
