      subroutine initt(fact,mode)    !,control)
C******************************************************************
C          INITIALIZE WINDOWS GRAPHICS
C******************************************************************
c          fact = ratio of drawing area size to full screen size
c          mode = 1 = use RGB@ for colors
c               = 0 = use 0-15 for colors
c               =-1 = for printer only, not screen
c          control = handle of plot window created
C******************************************************************
      common /C_handle/ ihandle
      external mouseCB
      integer*4 control
      save control
      INCLUDE <WINDOWS.INS>
 
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      common /c_color_mode/ color_mode
         integer*4 color_mode
      common /c_resolution/ resolution
         integer*4 resolution
      common /border_color/ iborder_color
      common /scalsetc/ xp,yp
      COMMON /HPCLIP/ LCLIP     !  =0=No clipping    =1=Clipping
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      integer*2 ifont(18),ifnt
      data ifont/0,1,2,3,101,102,103,104,105,106,107,108,109,110,
     +           111,112,113,114/
ccc      data scale640/.890/       !  scale factor for 640x480 screen
ccc      data scale800/.914/       !  scale factor for 800x600 screen
ccc      data scale640/.870/       !  scale factor for 640x480 screen
ccc      data scale800/.910/       !  scale factor for 800x600 screen
      data scale640/.750/       !  scale factor for 640x480 screen
      data scale800/.840/       !  scale factor for 800x600 screen
c
      idev=0                    !  screen is default
      LCLIP=1                   !  Turn clipping on
      lenx=GetSystemMetrics(SM_CXSCREEN)
      leny=GetSystemMetrics(SM_CYSCREEN)
      resolution=lenx    !  save for special needs of window sizes
      ffact=abs(fact)
      if(lenx.le.700) ffact=scale640
      if(lenx.eq.800) ffact=scale800
      if(lenx.le.800) then
         if(fact.gt.0) k=winio@('%ww[no_border,maximise]&')
      else
         if(fact.gt.0) k=winio@('%ww[no_border]&')
      end if
ccc      write(15,'('' in initt, lenx,leny='',2i5,f8.3)') lenx,leny,ffact
      lenx=nint(float(lenx)*ffact)
      leny=nint(float(leny)*ffact)
ccc      write(15,'('' in initt, lenx,leny='',2i5)') lenx,leny
c         keep Aspect Ratio same as on printer
      if(float(leny)/float(lenx).gt.2400./3160.) then
         leny=nint(float(lenx)*2400./3160.)
      else
         lenx=nint(float(leny)*3160./2400.)
      end if
      if(iresolut().eq.1) lenx=620   !  make X bigger for 640x480 screen
ccc      if(iresolut().eq.1) lenx=610   !  make X bigger for 640x480 screen
ccc      write(*,'('' in initt, lenx,leny='',2i5)') lenx,leny
      color_mode=mode
      control=-2
      if(fact.gt.0.) then
         if(mode.eq.0) then
            k=winio@('%ob%pv%^gr[white,metafile_resize]%cb%lw&',
     +            lenx,leny,mouseCB,control)
ccc            k=winio@('%ob%gr[white]%cb&',lenx,leny)
            call load_standard_colours@
         else if(mode.eq.1) then
            k=winio@('%ob%pv%^gr[rgb_colours,metafile_resize]%cb%lw&',
     +                lenx,leny,mouseCB,control)
ccc            k=winio@('%ob%gr[rgb_colours]%cb&',lenx,leny)
         else
         end if
         ihandle=control
      end if
      size=float(leny)/400.
      if(mode.ge.0 .and. fact.gt.0.) then
         do 10 i=1,4
         ifnt=ifont(i)
         call set_text_attribute@(ifnt,size,0.,0.)
10       call draw_text@('  ',0,0,0)
         call setext(102,1.,0.,0.,ichx,ichy)
      end if
      iborder_color=0           !  default is BLACK border
c********************************************************
ccc      call SetPalette           !  modify color palette
	xp=0
	yp=0
      MINSX=0                   !  VIEW PORT = WHOLE SCREEN
      MAXSX=LENX
      MINSY=0
      MAXSY=LENY
      WXMIN=MINSX               !  WINDOW = VIEW PORT
      WXMAX=MAXSX
      WYMIN=MINSY
      WYMAX=MAXSY
      XSCAL=1.                  !  USER COORDINATES=SCREEN COORDINATES
      YSCAL=1.                  !  USER COORDINATES=SCREEN COORDINATES
      RETURN
      END
C------------------------------------------------------------------
