      subroutine legend(parameter,labels,color,model,u,v,
     +                  ncolor,con,icolor,zmin,zmax,idigits)
c***********************************************************************
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      dimension con(*),icolor(*)
      character color*1,model*6,alf*20,label(3)*20,labels*(*)
      character azmin*7,azmax*7,parameter*8
      character model_6*10
c***********************************************************************
      ires=iresolut()       !  screen resolution
      iblack=icol_16(0)     !  black
      iwhite=icol_16(15)    !  white
      ipink=icol_16(13)     !  pink
      lblue=icol_16(14)     !  lite-lite blue
      if(idev.eq.2) then    !  color printer
         ipink=iwhite
         lblue=iwhite
      end if
      call jclpw(0)
      call getsize(lenx,leny)
      if(ires.eq.1) then           !  640x480 screen
         char_size=1.2
      else if(ires.eq.2) then      !  800x600 screen
         char_size=1.05
      else
         char_size=1.0
      end if
      call setext(4,.9*char_size,0.,0.,ichx,ichy)
      chx=ichx
      chy=ichy
ccc      ixr=lenx - ichx/2
      ixr=lenx
      ixl=ixr - chx*13.0
      if(ires.eq.1) ixl=ixl-chx*2.5
      yl=v-chy*4.
      if(ixr.gt.lenx) ixr=lenx-1
      iytt=v
      iyt=yl+chy*1.7
      iyb=yl-chy*7.
      if(color.ne.'B') then
         iyb=iyb - chy*1.3*float(ncolor)
c          allow for "Below SNRxx limit"
         if(parameter(1:3).eq.'SIR') iyb=iyb-chy*1.3*2.
      end if
      iybottom=iyb
      call scolor(iblack)
ccc      if(color.ne.'C') then       !  B/W
ccc         call rectang(ixl,iyt,ixr,iytt,-1,0,iblack)
ccc         call rectang(ixl,iyb,ixr,iyt,-1,0,iblack)
ccc      else                     !  color
         call rectang(ixl,iyt,ixr,iytt,iblack,0,iblack)
         call rectang(ixl,iyb,ixr,iyt,iblack,0,iblack)
ccc      end if
      dx=chx*.35
      dx=chx*.15
      ixl=ixl+dx
      ixr=ixr-dx
      iyt1=iyt+dx
      iyt2=iytt-dx
      iyb=iyb+dx
      iyt=iyt-dx
      if(color.ne.'C') then       !  color
         ipink=iwhite
         lblue=iwhite
      end if
      ipink=iwhite
      lblue=iwhite
      call rectang(ixl,iyt1,ixr,iyt2,ipink,0,iblack)
      call rectang(ixl,iyb,ixr,iyt,lblue,0,iblack)
      xc=(ixl+ixr)/2
      yc=float(iyt1+iyt2)/2.
      label(1)=labels( 1:20)
      label(2)=labels(21:40)
      label(3)=labels(41:60)
      call scolor(iblack)
      if(ires.eq.2) char_size=1.1      !  800x600 screen
      do 20 i=1,3
      call setext(4,.6*char_size,0.,0.,ichx,ichy)
      if(ires.eq.1) call setext(3,.85,0.,0.,ichx,ichy)
      nch=lcount(label(i),20)
      if(nch.eq.0) go to 20
      len=lentext(label(i)(1:nch))
      if(i.eq.3) len=len+chx*2.
      xl=xc-float(len)/2.    ! - ichx
ccc      if(xl.lt.ixl) then             !  make letters smaller
ccc         call setext(4,.5*char_size,0.,0.,ichx,ichy)
ccc         len=lentext(label(i)(1:nch))
ccc         if(i.eq.3) len=len+chx*2.
ccc         xl=xc-float(len)/2.
ccc      end if
      call plotabs(xl,yl,3)
      call textc(nch,label(i))
20    yl=yl-chy
      if(ires.eq.1) char_size=1.6      !  640x480 screen
      call setext(4,.6*char_size,0.,0.,ichx,ichy)
      yl=yl-chy
      ix0=ixl+chx*2.
      ix1=ix0+chx*5.
      if(color.eq.'B') go to 55   !  Not color
      do 50 i=ncolor,1,-1
      call scolor(iblack)
c********************************
      if(idigits.eq.0) then
         nch=5
         if(i.gt.1) then
            write(alf,'(1H>,i4)') nint(con(i-1))
         else
            write(alf,'(1h<,i4)') nint(con(i))
         end if
      else if(idigits.eq.1) then
         nch=5
         if(i.gt.1) then
            write(alf,'(1H>,f4.1)') con(i-1)
         else
            write(alf,'(1h<,f4.1)') con(i)
         end if
      else
         nch=6
         if(i.gt.1) then
            write(alf,'(1H>,f5.2)') con(i-1)
         else
            write(alf,'(1h<,f5.2)') con(i)
         end if
      end if
c********************************
      call plotabs(float(ix1)+chx,yl,3)
      call textc(nch,alf)
ccc      write(15,'('' con('',i2,'')='',f10.3,2x,a5)') i,con(i),alf
      iy0=yl
      iy1=yl+chy
      if(color.eq.'S') then        !  B/W with no fill
         call rectang(ix0,iy0,ix1,iy1,iblack,icolor(i),iblack)
      else
         icol=icol_16(icolor(i))
         call rectang(ix0,iy0,ix1,iy1,icol,0,iblack)
      end if
ccc      call scolor(iblack)
ccc      call rectang(ix0,iy0,ix1,iy1,-1,0,iblack)
50    yl=yl-chy*1.3
55    call scolor(iblack)

      call setext(4,.6*char_size,0.,0.,ichx,ichy)        !  courier text

      if(parameter(1:3).eq.'SIR' .and. color.ne.'B') then
         alf(1:11)='Below SNRxx'
         len=lentext(alf(1:11))
         yl=yl-chy*.6
         xxl=xc-len/2.
         call plotabs(xxl,yl,3)
         call textc(11,alf)
         alf(1:11)='limit'
         yl=yl-chy
         call plotabs(xxl,yl,3)
         call textc(5,alf)
         ix0=xxl+ichx*5.5
         ix1=ix0+ichx*5
         iy0=yl-chy*.1
         iy1=yl+chy*.9
         call rectang(ix0,iy0,ix1,iy1,15,0,iblack)   !  white interior
         yl=yl-chy*.5
      end if

      call f7format(zmin,azmin)
      call f7format(zmax,azmax)
      alf(1:11)='Min='//azmin
      len=lentext(alf(1:11))
      yl=yl-chy
      call plotabs(xc-len/2.,yl,3)
      call textc(11,alf)
      yl=yl-chy
      call plotabs(xc-len/2.,yl,3)
      alf(1:11)='Max='//azmax
      call textc(11,alf)

      call setext(106,1.3,0.,0.,ichx,ichy)        !  large text
      model_6=model
      model_6=parameter
      nch_m=lenchar(model_6)
      len=lentext(model_6(1:nch_m))
      call plotabs(xc-float(len)-ichx*.5,yc-ichy*.5,3)
      call textc(nch_m,model_6)
      iyversion=v
      call plotvers(ixl,iyversion)
      return
      end
c-----------------------------------------------------------------------
